Name: db
Version: 4.8.30
Release: 3
License: Sleepycat
Summary: The Berkeley Database, the Open Source embedded database system
Url: http://www.sleepycat.com/index.html

BuildRequires: pase-build-tools

# Source0: http://www.sleepycat.com/update/%{version}/db-%{version}.tar.gz
Source0: db-%{version}.tar.bz2

Patch0: db-pase.patch

%description
Berkley DB is a programmatic toolkit that provides high-performance built-in 
database support for desktop and server applications and for information 
appliances.

The Berkeley DB access methods include B+tree, Extended Linear Hashing, Fixed 
and Variable-length records, and Queues.  Berkeley DB provides full 
transactional support, database recovery, online backups, and separate
access to locking, logging and shared memory caching subsystems.

Berkeley DB supports C, C++, Java, Tcl, Perl, and Python APIs.

%package devel
Summary: Development files for Berkeley DB
Requires: libdb48 = %{version}

%description devel
Development files for Berkeley DB

%package -n libdb48
Summary: Berkeley DB libraries

%description -n libdb48
Berkeley DB libraries




%prep
%setup -q

%patch0 -p1

%build

# TODO: fix autoreconf
%define reconf 0

# TODO: add aix-soname support
%define soname_aix 0

%if %{reconf}
autoreconf -fi
%endif

cd build_unix

# If we don't set LIBSO_LIBS, we get unresolved pthread symbols
#  when linking the db library.
../dist/configure \
  DUMPBIN=: \
  LDFLAGS='-Wl,-brtl -Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib -L%{_libdir}' \
  LIBSO_LIBS=-lpthread \
  CC="gcc -maix${OBJECT_MODE}" \
  --prefix=%{_prefix} \
%if %{reconf} == 0
  --host=powerpc-ibm-aix6 \
%endif
%if %{soname_aix}
  --with-aix-soname=svr4 \
%endif
  --enable-compat185 \
  --enable-shared \
  --disable-static \

make


%if %{soname_aix} == 0
cd .libs

mv libdb-4.8.so libdb.so.4.8
ln -s libdb.so.4.8 libdb-4.8.so

name=libdb.so.4.8
soname=libdb.so.4.8

svr4-shrlib $name $soname %{_arch}

ln -s $soname libdb.so

touch libdb-4.8.la

cd ..

make

%endif


#Patch on-the-fly  (DB185 is only used internally; not available for
# the packaged db_185.h file).
cp db_185.h db_185.h.orig

perl -pi -e "s|^DB185|DB|" db_185.h

# cd ..

# /usr/bin/ar -qv build_unix/.libs/libdb-4.8.a build_unix/.libs/libdb-4.8.so


%install

cd build_unix

make prefix=%{buildroot}%{_prefix} install

cp .libs/libdb.so* %{buildroot}/%{_libdir}

diff -u db_185.h.orig db_185.h || :

mkdir -p %{buildroot}/%{_libdir}/pkgconfig
cat <<EOF > %{buildroot}%{_libdir}/pkgconfig/db.pc
prefix=%{_prefix}
exec_prefix=%{_exec_prefix}
libdir=%{_libdir}
includedir=%{_includedir}

Name: db
Description: %{summary}
URL: %{url}
Version: %{version}
Cflags: -I${includedir}
Libs: -L${libdir} -ldb-4.8
EOF


find %{buildroot}/%{_libdir} -name \*.la | xargs rm

rm -r %{buildroot}%{_prefix}/docs

%files
%defattr(-, qsys, *none)

%{_bindir}/db_archive
%{_bindir}/db_checkpoint
%{_bindir}/db_deadlock
%{_bindir}/db_dump
%{_bindir}/db_hotbackup
%{_bindir}/db_load
%{_bindir}/db_printlog
%{_bindir}/db_recover
%{_bindir}/db_sql
%{_bindir}/db_stat
%{_bindir}/db_upgrade
%{_bindir}/db_verify

%files -n libdb48
%defattr(-, qsys, *none)

%{_libdir}/libdb.so.4.8

%files devel
%defattr(-, qsys, *none)

%{_libdir}/libdb-4.8.so
%{_libdir}/libdb-4.so
%{_libdir}/libdb.so

%{_libdir}/pkgconfig/db.pc

%{_includedir}/db.h
%{_includedir}/db_cxx.h
%{_includedir}/db_185.h

%changelog
* Thu Aug 08 2019 Kevin Adler <kadler@us.ibm.com> - 4.8.30
- Fix build failure

* Tue Mar 26 2019 Kevin Adler <kadler@us.ibm.com> - 4.8.30
- ibm-build-tools -> pase-build-tools

* Tue Mar 13 2018 - Kevin Adler <kadler@us.ibm.com>
- Use mkdir -p to make docdir in build root

* Tue Mar 13 2018 - Kevin Adler <kadler@us.ibm.com>
- Split in to subpackages

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- Mass replace svr4_shlib.sh -> svr4-shrlib

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove 64-bit GCC script workarounds
- OBJECT_MODE now always set by build and install macros

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove commented out files
- Package specific files
- Remove libtool .la files

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove outdated TODO comments

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Use auto dependency resolution instead of requiring pase-libs

* Fri Sep 15 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix GNU coreutils link build issue
